/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
TIM_HandleTypeDef htim4;

UART_HandleTypeDef huart1;

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
uint8_t encCounter;


uint8_t receiveBuffer[10];
uint8_t byte;
int size,size2;
uint8_t CardName[4]="7i99";
uint16_t SwRevision,HwRevision;
uint16_t NVWatchDogTimeout,NVBaudRate;
uint32_t NVUnitNumber,UnitNumber;
uint8_t gtoc_msb,gtoc_lsb;
uint8_t ptoc_msb,ptoc_lsb;
uint8_t bytes_in,bytes_out; 
uint8_t sw_mode_index,hw_mode_index=1;

uint8_t saw,feed_overide; 




uint8_t CRC_table[256] =    			 {0, 94, 188, 226, 97, 63, 221, 131, 194, 156, 126, 32, 163, 253, 31, 65,
                                    157, 195, 33, 127, 252, 162, 64, 30, 95, 1, 227, 189, 62, 96, 130, 220,
                                    35, 125, 159, 193, 66, 28, 254, 160, 225, 191, 93, 3, 128, 222, 60, 98,
                                    190, 224, 2, 92, 223, 129, 99, 61, 124, 34, 192, 158, 29, 67, 161, 255,
                                    70, 24, 250, 164, 39, 121, 155, 197, 132, 218, 56, 102, 229, 187, 89, 7,
                                    219, 133, 103, 57, 186, 228, 6, 88, 25, 71, 165, 251, 120, 38, 196, 154,
                                    101, 59, 217, 135, 4, 90, 184, 230, 167, 249, 27, 69, 198, 152, 122, 36,
                                    248, 166, 68, 26, 153, 199, 37, 123, 58, 100, 134, 216, 91, 5, 231, 185,
                                    140, 210, 48, 110, 237, 179, 81, 15, 78, 16, 242, 172, 47, 113, 147, 205,
                                    17, 79, 173, 243, 112, 46, 204, 146, 211, 141, 111, 49, 178, 236, 14, 80,
                                    175, 241, 19, 77, 206, 144, 114, 44, 109, 51, 209, 143, 12, 82, 176, 238,
                                    50, 108, 142, 208, 83, 13, 239, 177, 240, 174, 76, 18, 145, 207, 45, 115,
                                    202, 148, 118, 40, 171, 245, 23, 73, 8, 86, 180, 234, 105, 55, 213, 139,
                                    87, 9, 235, 181, 54, 104, 138, 212, 149, 203, 41, 119, 244, 170, 72, 22,
                                    233, 183, 85, 11, 136, 214, 52, 106, 43, 117, 151, 201, 74, 20, 246, 168,
                                    116, 42, 200, 150, 21, 75, 169, 247, 182, 232, 10, 84, 215, 137, 107, 53};


uint8_t PTOCtable [60] ;
uint8_t GTOCtable [60] ;
uint8_t *pTOCtable;
																		
typedef struct {
   uint8_t record_type;
   uint8_t data_size;
   uint8_t data_type;
   uint8_t data_direction;
   uint32_t param_min;
   uint32_t param_max;
   uint16_t param_addr;
   uint8_t unit_and_name_string[25];
} PROCESS_DATA_DESCRIPTOR;

typedef struct {
    uint8_t record_type;
    uint8_t mode_index;
    uint8_t mode_type;
    uint8_t unused;
    char mode_name_string[8];
} MODE_DESCRIPTOR;





																		
PROCESS_DATA_DESCRIPTOR pdd_rec[10]  =              //number of items must be same as number of lines in definition 
			{	
			0xa0,0x08, 0x01, 0x80, 0, 0, 0x0000, "bit\x00" "OUT\x00",
			0xa0,0x08, 0x01, 0x00, 0, 0, 0x0000, "bit\x00" "INP\x00",
			0xa0,0x10, 0x02, 0x80, 0, 0x40000000, 0x0000, "pin\x00" "feed-overide\x00",
			0xa0,0x08, 0x08, 0x00, 0, 0, 0x0000, "count\x00" "ENCODER\x00",
			0xa0,0x10, 0x02, 0x80, 0, 0, 0x0000, "None\x00" "SwRevision\x00",
		  0xa0,0x10, 0x02, 0x80, 0, 0, 0x0000, "None\x00" "HwRevision\x00",
			0xa0,0x10, 0x04, 0x00, 0, 0, 0x0000, "None\x00" "NVWatchDogTimeout\x00",
			0xa0,0x20, 0x04, 0x00, 0, 0, 0x0000, "None\x00" "NVUnitNumber\x00",
			0xa0,0x10, 0x04, 0x40, 0, 0, 0x0000, "None\x00" "NVBaudRate\x00",
			0xa0,0x20, 0x04, 0x00, 0, 0, 0x0000, "None\x00" "UnitNumber\x00",
			};




MODE_DESCRIPTOR md_rec [2] = 
// RECORD_type, MODE_index ,MODE_type, unused , mode name string
		{0xb0, 0x00, 0x00, 0x00, "hw0 ",
		 0xb0, 0x02, 0x01, 0x00, "sw0 "};
		 
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_TIM4_Init(void);
static void MX_USART1_UART_Init(void);
/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */




	SwRevision=0x5555;
	pdd_rec[4].param_addr = (uintptr_t)&SwRevision;     //add address to param_addr for swrevision
	HwRevision=0x0123;
	pdd_rec[5].param_addr = (uintptr_t)&HwRevision;
	NVWatchDogTimeout=0x00ff;
	pdd_rec[6].param_addr = (uintptr_t)&NVWatchDogTimeout;
	NVUnitNumber=0x12121212;
	pdd_rec[7].param_addr = (uintptr_t)&NVUnitNumber;
	NVBaudRate=0x0003;
	pdd_rec[8].param_addr = (uintptr_t)&NVBaudRate;
	UnitNumber=0x25121314;
	pdd_rec[9].param_addr = (uintptr_t)&UnitNumber;
	
	
  size=sizeof(md_rec)/sizeof(MODE_DESCRIPTOR);
	size2=sizeof(pdd_rec)/sizeof(PROCESS_DATA_DESCRIPTOR);
	//GTOC   all mdrec and all ptoc (proces data + variables )
	
  //for (int i=0; i < sizeof(md_rec)/sizeof(MODE_DESCRIPTOR); i++) {
  for (int i=0; i < 10; i++) {

		GTOCtable[2*i+4]   = (uintptr_t)(&pdd_rec[i]);
		GTOCtable[2*i+5] = ((uintptr_t)&pdd_rec[i]>>8);
    }
	GTOCtable[0]=(uintptr_t)(&md_rec[0]);     //natvrdo hw a sw mode
	GTOCtable[1]=((uintptr_t)&md_rec[0]>>8);
	GTOCtable[2]=(uintptr_t)(&md_rec[1]);
	GTOCtable[3]=((uintptr_t)&md_rec[1]>>8);
		
	gtoc_lsb = (uintptr_t)(&GTOCtable[0]);
	gtoc_msb = (uintptr_t)(&GTOCtable[0])>>8 ;
		
	// PTOC  pdd without variables
		
		//for (int i=0; i < sizeof(pdd_rec)/sizeof(PROCESS_DATA_DESCRIPTOR); i++) {
		for (int i=0; i < 4; i++) {
			PTOCtable[2*i+4]   = (uintptr_t)(&pdd_rec[i]);
			PTOCtable[2*i+5] = ((uintptr_t)&pdd_rec[i]>>8);
		}
	PTOCtable[0]=(uintptr_t)(&md_rec[0]);     //natvrdo hw a sw mode
	PTOCtable[1]=((uintptr_t)&md_rec[0]>>8);
	PTOCtable[2]=(uintptr_t)(&md_rec[1]);
	PTOCtable[3]=((uintptr_t)&md_rec[1]>>8);
	bytes_in =  3;
	bytes_out = 5;
		
	ptoc_lsb = (uintptr_t)(&PTOCtable[0]);
	ptoc_msb = (uintptr_t)(&PTOCtable[0])>>8;
	hw_mode_index=1;
		
		
	
		
		
  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_TIM4_Init();
  MX_USART1_UART_Init();
  /* USER CODE BEGIN 2 */
  __HAL_UART_ENABLE_IT(&huart1, UART_IT_RXNE);    //enable interrupt RX not empty
  HAL_UART_Receive_IT(&huart1, &byte, 1);
	HAL_TIM_Encoder_Start_IT(&htim4,TIM_CHANNEL_ALL);
  /* USER CODE END 2 */
 
 

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
		
	  //HAL_GPIO_TogglePin (GPIOC, GPIO_PIN_13);
		HAL_Delay (50);
		saw++;
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */

  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief TIM4 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM4_Init(void)
{

  /* USER CODE BEGIN TIM4_Init 0 */

  /* USER CODE END TIM4_Init 0 */

  TIM_Encoder_InitTypeDef sConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM4_Init 1 */

  /* USER CODE END TIM4_Init 1 */
  htim4.Instance = TIM4;
  htim4.Init.Prescaler = 0;
  htim4.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim4.Init.Period = 255;
  htim4.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim4.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  sConfig.EncoderMode = TIM_ENCODERMODE_TI12;
  sConfig.IC1Polarity = TIM_ICPOLARITY_RISING;
  sConfig.IC1Selection = TIM_ICSELECTION_DIRECTTI;
  sConfig.IC1Prescaler = TIM_ICPSC_DIV1;
  sConfig.IC1Filter = 0;
  sConfig.IC2Polarity = TIM_ICPOLARITY_RISING;
  sConfig.IC2Selection = TIM_ICSELECTION_DIRECTTI;
  sConfig.IC2Prescaler = TIM_ICPSC_DIV1;
  sConfig.IC2Filter = 2;
  if (HAL_TIM_Encoder_Init(&htim4, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim4, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM4_Init 2 */

  /* USER CODE END TIM4_Init 2 */

}

/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  huart1.Instance = USART1;
  huart1.Init.BaudRate = 2500000;
  huart1.Init.WordLength = UART_WORDLENGTH_8B;
  huart1.Init.StopBits = UART_STOPBITS_1;
  huart1.Init.Parity = UART_PARITY_NONE;
  huart1.Init.Mode = UART_MODE_TX_RX;
  huart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart1.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART1_Init 2 */

  /* USER CODE END USART1_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_13, GPIO_PIN_RESET);

  /*Configure GPIO pin : PC13 */
  GPIO_InitStruct.Pin = GPIO_PIN_13;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  while(1) 
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
