/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    stm32f1xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f1xx_it.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */

/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
 
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
#define LBPCOMMAND				0x40	  // Command function 
#define LBPFUNCTIONMASK		0xC0		
#define LBPRWMASK					0x20
#define	LBPADDMASK				0x04


//RPC
#define	LBPRPC						0x80		//Rpc commands 0..63	1000 0000

//LBP
#define LBPLOCAL					0xC0		//local LBP 0-31
#define LBPCOMMAND				0x40		//Command function	0100 0000
#define LBPWRITE					0x20		//Write command			0010 0000
#define LBPA2							0x04		//Two byte address included    0 to specify current address, 1 to specify 2 byte address.
#define LBPAUTOINC				0x08  	//Auto increment 
#define LBPDATASIZE				0x03		//Data Size  00b = 1 bytes, 01b = 2 bytes, 10 b= 4 bytes, 11b = 8 bytes.
#define LBPCOOKIECODE			0x5A 		//return for read cookie

#define LBPD1							0x00						//byte	One byte data
#define LBPD2							0x01						//byte	Two byte data
#define LBPD4							0x02						//byte	Four byte data
#define LBPD8							0x03						//byte	Eight byte data

extern uint8_t encCounter;
		 
extern uint8_t receiveBuffer[];
extern char* transmitBuffer;
extern  uint8_t CRC_table[];
extern uint8_t PTOCtable[];
extern uint8_t GTOCtable[]; 
extern uint8_t *pTOCtable;
uint16_t *addr,value;
extern uint8_t gtoc_msb,gtoc_lsb;
extern uint8_t ptoc_msb,ptoc_lsb;
extern uint8_t bytes_in,bytes_out;
extern uint8_t sw_mode_index,hw_mode_index;
extern uint8_t CardName[];
extern uint8_t saw,feed_overide;
int count;
int data_ready=0;
int zapis;

extern uint8_t byte;
uint8_t pos_RX,command;
uint16_t readaddr;
uint8_t bytes2read = 0xee,bytes2send;
uint8_t RXBUFF [20];
uint8_t TXBUFF [20];
uint8_t TXcrc;
uint8_t LBPstatus;
int CalcCRC(uint8_t data_byte, uint8_t crc);
void send_back (void);

/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
extern UART_HandleTypeDef huart1;
/* USER CODE BEGIN EV */

/* USER CODE END EV */

/******************************************************************************/
/*           Cortex-M3 Processor Interruption and Exception Handlers          */ 
/******************************************************************************/
/**
  * @brief This function handles Non maskable interrupt.
  */
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */

  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
  * @brief This function handles Hard fault interrupt.
  */
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */

  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Memory management fault.
  */
void MemManage_Handler(void)
{
  /* USER CODE BEGIN MemoryManagement_IRQn 0 */

  /* USER CODE END MemoryManagement_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_MemoryManagement_IRQn 0 */
    /* USER CODE END W1_MemoryManagement_IRQn 0 */
  }
}

/**
  * @brief This function handles Prefetch fault, memory access fault.
  */
void BusFault_Handler(void)
{
  /* USER CODE BEGIN BusFault_IRQn 0 */

  /* USER CODE END BusFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_BusFault_IRQn 0 */
    /* USER CODE END W1_BusFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Undefined instruction or illegal state.
  */
void UsageFault_Handler(void)
{
  /* USER CODE BEGIN UsageFault_IRQn 0 */

  /* USER CODE END UsageFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_UsageFault_IRQn 0 */
    /* USER CODE END W1_UsageFault_IRQn 0 */
  }
}

/**
  * @brief This function handles System service call via SWI instruction.
  */
void SVC_Handler(void)
{
  /* USER CODE BEGIN SVCall_IRQn 0 */

  /* USER CODE END SVCall_IRQn 0 */
  /* USER CODE BEGIN SVCall_IRQn 1 */

  /* USER CODE END SVCall_IRQn 1 */
}

/**
  * @brief This function handles Debug monitor.
  */
void DebugMon_Handler(void)
{
  /* USER CODE BEGIN DebugMonitor_IRQn 0 */

  /* USER CODE END DebugMonitor_IRQn 0 */
  /* USER CODE BEGIN DebugMonitor_IRQn 1 */

  /* USER CODE END DebugMonitor_IRQn 1 */
}

/**
  * @brief This function handles Pendable request for system service.
  */
void PendSV_Handler(void)
{
  /* USER CODE BEGIN PendSV_IRQn 0 */

  /* USER CODE END PendSV_IRQn 0 */
  /* USER CODE BEGIN PendSV_IRQn 1 */

  /* USER CODE END PendSV_IRQn 1 */
}

/**
  * @brief This function handles System tick timer.
  */
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */

  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  /* USER CODE BEGIN SysTick_IRQn 1 */

  /* USER CODE END SysTick_IRQn 1 */
}

/******************************************************************************/
/* STM32F1xx Peripheral Interrupt Handlers                                    */
/* Add here the Interrupt Handlers for the used peripherals.                  */
/* For the available peripheral interrupt handler names,                      */
/* please refer to the startup file (startup_stm32f1xx.s).                    */
/******************************************************************************/

/**
  * @brief This function handles USART1 global interrupt.
  */
void USART1_IRQHandler(void)
{
  /* USER CODE BEGIN USART1_IRQn 0 */

  /* USER CODE END USART1_IRQn 0 */
  HAL_UART_IRQHandler(&huart1);
  /* USER CODE BEGIN USART1_IRQn 1 */
encCounter = TIM4->CNT;
if (bytes2read == (uint8_t)0xEE) 													// prvni byte - command
	{
//	HAL_UART_Receive_IT(&huart1, &byte, 1);
//																																									HAL_UART_Transmit(&huart1,p,1,5);
	pos_RX=0;
	command = byte;

	switch (command & LBPFUNCTIONMASK) {
		case	LBPRPC : 														//rpc command		10xx xxxx
				switch (command){

					case 0xBB:
					case 0xBC:
						bytes2read = 1;
						break;
					case 0xBD:
						bytes2read = bytes_out+1;
						break;
					default :	bytes2read = 0xEE;
						break;
				}
				break;
		case	LBPCOMMAND:														//LBP read/write 	01xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP write		xx1x xxxx
				{
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
					bytes2read = 3;
					}
					else														//No address included, Last address used xxxx x0xx
					{
					bytes2read = 1;
					}
					bytes2read+=(uint8_t)(1 << (command & LBPDATASIZE));  //DataSize: Specifies data size, 00b = 1 bytes, 01b = 2 bytes, 10 b= 4 bytes, 11b = 8 bytes.
					zapis=(1 << (command & LBPDATASIZE));
				}
				else 															//LBP read data	xx0x xxxx
				{
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
					bytes2read = 3;
					}
					else														//No address included, Last address used xxxx x0xx
					{
					bytes2read = 1;
					}
				}
				break;
		case LBPLOCAL:															//LBP local function 0-31 11xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP local write func		xx1x xxxx 0xE0 a dal
				{
					//
					switch (command){
						case 0xE1:
						case 0xE6:
						case 0xE7:
						case 0xEB:
						case 0xEC:
								bytes2read = 2;
							break;
						default :	bytes2read = 0xEE;
							break;
					}
					//
				}
				else 															//LBP 	local read func x0x xxxx		0xc0 - 0xdf
				{
					switch (command){
						case 0xC1:
						case 0xC7:
						case 0xD0:
						case 0xD1:
						case 0xD2:
						case 0xD3:
						case 0xD4:
						case 0xD5:
						case 0xD6:
						case 0xD7:
						case 0xDF: 	
							bytes2read = 1;
							break;
						default :	bytes2read = 0xEE;
							break;
					}
				}
				break ;
		default:	bytes2read = 0xEE	;					//nemelo by nastat  00

			break;										
		}
	}
else 																				// dalsi byte
	{
	//HAL_UART_Receive_IT(&huart1, &byte, 1);
	RXBUFF[pos_RX] = byte ;
	bytes2read--;
	if(bytes2read == 0) 														// posledni byte vyhodnotit retezec
		{
			bytes2read = 0xEE;
			if (data_ready) {

				HAL_GPIO_WritePin (GPIOC, GPIO_PIN_13, (GPIO_PinState) (RXBUFF[0] && 0x01 ));
				
				
				data_ready=0;
				
			}
				
					
			send_back();		
		}
	else 
		{
		pos_RX++;
		}
	}
  HAL_UART_Receive_IT(&huart1, &byte, 1);   //read next byte

  /* USER CODE END USART1_IRQn 1 */
}

/* USER CODE BEGIN 1 */
void send_back (void) 
	{
	switch (command & LBPFUNCTIONMASK) {
		case	LBPRPC :{ 														//rpc command		10xx xxxx
			switch (command){
				case 0xBB:																									//GetDiscoveryInfo"
                         
						TXBUFF[0] = bytes_in;																			// number of bytes in
						TXBUFF[1] = bytes_out; 																		// number of bytes out
						TXBUFF[2] = ptoc_lsb; 															 // PTOC address             
						TXBUFF[3] = ptoc_msb ;                
						TXBUFF[4] = gtoc_lsb;																	// GTOC address
						TXBUFF[5] = gtoc_msb;
						bytes2send = 7;
				break;
			case 0xBC:																									//GetUnitNumber"
																																		// return 4 bytes + CRC
						TXBUFF[0] = 0x12;
						TXBUFF[1] = 0x12;
						TXBUFF[2] = 0x12;
						TXBUFF[3] = 0x12;
						bytes2send = 5;
						//WriteUART1(TX1_buf[0]);
				break;
			case 0xBD:														//ProcessDataRPC 
						feed_overide = RXBUFF[0];
						TXBUFF[0] = 0x00;								//fault info
						TXBUFF[1] = saw; 								//
						TXBUFF[2] = encCounter;
						count++;								//data
						
						bytes2send = bytes_in +1 ;   //+1 crc
						data_ready=1;
				break;
				}
			}
		break;
		case	LBPCOMMAND:{														//LBP read/write 	01xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP write		xx1x xxxx
				{
			//TODO write
					
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
					addr=((uint16_t*)((uint32_t)((RXBUFF[1]<<8)|RXBUFF[0])|SRAM_BASE));
					switch (command & LBPDATASIZE) {
						case LBPD1:										
									break;
						
						case LBPD2:
									value=((uint16_t)((RXBUFF[3]<<8)|RXBUFF[2]));
									*addr=value;
									break;
						}	
					
					TXBUFF[0]=0x00; 						//no crc
					bytes2send=1;
					}
					
				}
				else 															//LBP read data	xx0x xxxx
				{
					if ((command & LBPADDMASK) == LBPA2)							//Two byte address included xxxx x1xx
					{
						pTOCtable=((uint8_t*)((uint32_t)((RXBUFF[1]<<8)|RXBUFF[0])|SRAM_BASE));
						switch (command & LBPDATASIZE) {
							case LBPD1:
									if (pTOCtable == NULL) bytes2read=0xEE;
									else TXBUFF[0]=*pTOCtable;
												bytes2send=2;
													
									break;
							case LBPD2:
									TXBUFF[0]=*pTOCtable;
									TXBUFF[1]=*(pTOCtable+1);
									bytes2send=3;
									break;
							case LBPD4:
									TXBUFF[0]=*pTOCtable;
									TXBUFF[1]=*(pTOCtable+1);
									TXBUFF[2]=*(pTOCtable+2);
									TXBUFF[3]=*(pTOCtable+3);
									bytes2send=5;
									break;
							case LBPD8:
									TXBUFF[0]=*pTOCtable;
									TXBUFF[1]=*(pTOCtable+1);
									TXBUFF[2]=*(pTOCtable+2);
									TXBUFF[3]=*(pTOCtable+3);
									TXBUFF[4]=*(pTOCtable+4);
									TXBUFF[5]=*(pTOCtable+5);
									TXBUFF[6]=*(pTOCtable+6);
									TXBUFF[7]=*(pTOCtable+7);
									
									bytes2send=9;
									break;
							
							}
					}
					else														//No address included, Last address used xxxx x0xx
					{
						TXBUFF[0]=*pTOCtable;
							bytes2send=2;
					}
					if(command &&  LBPAUTOINC == LBPAUTOINC) {  //AutoInc: 0 leaves address unchanged, 1 specifies that address is post incremented by data size in bytes.
            pTOCtable += (1 << (command & LBPDATASIZE));  //DataSize: Specifies data size, 00b = 1 bytes, 01b = 2 bytes, 10 b= 4 bytes, 11b = 8 bytes.
						}
				}
			}
				break;
		case LBPLOCAL:{															//LBP local function 0-31 11xx xxxx
				if ((command & LBPRWMASK) ==  LBPWRITE)								//LBP local write func		xx1x xxxx 0xE0 a dal
				{
					//
					switch (command){
						case 0xEB:
						case 0xE1:
							LBPstatus = RXBUFF[0];
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
							break;
						case 0xE6:
							sw_mode_index=RXBUFF[0]; 				// setup sw mode
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
							break;											
						case 0xE7:										//clear faults
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
						case 0xEC:										//nejaky potvrzeni
							TXBUFF[0]=0x00; 						//no crc
							bytes2send=1;
					}
				}
				else 															//LBP 	local read func x0x xxxx		0xc0 - 0xdf
				{
					switch (command){
						
						case 0xDF:										//hallo
							TXBUFF[0]=LBPCOOKIECODE ; 	//0x5A
							bytes2send=2;
							break;
						case 0xC1:											// get LBP status
							TXBUFF[0]=LBPstatus;
							bytes2send=2;
							break;
						case 0xC7:											// read state  nonzero = bussy
							TXBUFF[0]=LBPstatus;
							bytes2send=2;
							break;
						case 0xD0:
							TXBUFF[0]=CardName[0];
							bytes2send=2;
							break;
						case 0xD1:
							TXBUFF[0]=CardName[1];
							bytes2send=2;
							break;
						case 0xD2:
							TXBUFF[0]=CardName[2];
							bytes2send=2;
							break;
						case 0xD3:
							TXBUFF[0]=CardName[3];
							bytes2send=2;
							break;
						default :	bytes2read = 0xEE;
							break;
					}
				}
				break ;
			}
		default:		;					//nemelo by nastat  00
				
				

				
			break;										
		}	
		// calc crc
		TXcrc=0;
		for (int i=0; i < bytes2send -1 ; i++) {
			TXcrc=CalcCRC (TXBUFF[i] , TXcrc);
		}
		TXBUFF[bytes2send-1] = TXcrc;
		//  send data 
		HAL_UART_Transmit(&huart1,TXBUFF,bytes2send,5);
	
		
}
	
int CalcCRC(uint8_t	data_byte, uint8_t crc)
{
	return  CRC_table[crc ^ data_byte];
}

/* USER CODE END 1 */
/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
