#ifndef KEYPAD_H__
#define KEYPAD_H__

#include "stm32f4xx.h"
//---------------------------------------------------------

typedef struct {
	uint32_t ncols;   //pocet sloupcu
	uint32_t nrows;   //pocet radku
	uint32_t rowshift;		//posun radku o pocet bitu
	uint32_t keydown;
	uint32_t keyup;
	uint32_t numkeys;
	uint32_t keybuffer[10];      //keybuffer
	uint32_t now[4];
	uint32_t then[4];
	uint8_t row;				//aktualni radek cteni
	uint32_t mask;			//maska podle poctu bitu
	uint32_t scan;
	uint32_t keycode;			//keykode
	uint8_t rollover;     //soucasne stiskutych klaves
	uint8_t keysend[30];
	uint8_t	keypos;
	
}KP_INST;

extern KP_INST keypad_inst;

void keypad_init (uint8_t columns, uint8_t rows);
void keypad_read (void);
  

//---------------------------------------------------------
#endif /*KEYPAD_H_ */ 

